import java.io.*;
import java.util.*;

public class Main {
    static int mod = 1000000007;
    static long[]factorial;
    public static void main(String[] args) throws IOException {
        String s1 = nextToken();
        String s2 = nextToken();
        String s3 = nextToken();
        int n = s1.length();
        factorial = new long[n];
        factorial[0] = 1;
        for (int i = 1; i < n; i++) {
            factorial[i] = (factorial[i - 1] * (i + 1)) % mod;
        }
        int[][] types = new int[4][2];
        for (int i = 0; i < n; i++) {
            int a = Integer.parseInt(s1.substring(i, i + 1));
            int b = Integer.parseInt(s2.substring(i, i + 1));
            int c = Integer.parseInt(s3.substring(i, i + 1));
            int type = -1;
            if (a + b == c) {
                type = 0;
            }
            else if (a + b == c - 1) {
                type = 1;
            }
            else if (a + b == c + 10) {
                type = 2;
            }
            else if (a + b == c + 9) {
                type = 3;
            }
            else {
                out.print(0);
                out.close();
                return;
            }
            types[type][0]++;
            if (a == 0 || b == 0 || c == 0) {
                types[type][1]++;
            }
        }
        if (types[2][0] > types[1][0] || types[1][0] - types[2][0] > 1) {
            out.print(0);
            out.close();
            return;
        }
        if (types[1][0] - types[2][0] == 1 && types[0][0] == 0) {
            out.print(0);
            out.close();
            return;
        }
        long ans = 0;
        ans += ((types[0][0] - types[0][1]) * (super_solver(Math.max(0, types[0][0] - 1), types[1][0], types[2][0], types[3][0]))) % mod;
        ans += ((types[1][0] - types[1][1]) * (super_solver(types[0][0], Math.max(0, types[1][0] - 1), types[2][0], types[3][0]))) % mod;
        out.println(ans % mod);
        out.close();
    }

    public static long super_solver(int a, int b, int c, int d) {
        long ans = 1;
        if (b >= c) {
            ans = (ans * f(b)) % mod;
            ans = (ans * f(c)) % mod;
            ans = (ans * f1(Math.max(1, b), Math.max(1, b) + d - 1)) % mod;
            ans = (ans * f1(c + 1, c + a)) % mod;
        }
        else {
            ans = (ans * f(b)) % mod;
            ans = (ans * f(c)) % mod;
            ans = (ans * f1(b + 1, b + d)) % mod;
            ans = (ans * f1(Math.max(1,c), Math.max(1,c) + a - 1)) % mod;
        }
        return ans;
    }

    public static long f(int n) {
        if (n == 0) {
            return 1;
        }
        return factorial[n - 1];
    }

    public static long f1(int a, int b) {
        if (b < a) {
            return 1;
        }
        long ans = a;
        for (int i = a + 1; i <= b; i++) {
            ans *= i;
            ans %= mod;
        }
        return ans;
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}